/**
 * Funci que posiciona el label associat a cada input a la posici correcta
 */
function posiciona() {
  $("input, textarea").each(function() {
    var $el = $(this);
    var label = $("label[for='" + $el.attr('id') + "']");
    label.css('left', $el.position().left + 12);
    label.css('top', $el.position().top - 20);
    if ($el.val()) {
      $el.addClass('filled');
    } else {
      $el.removeClass('filled');
    }
  });
}

$(function() {
  // Crea a cada input i textarea un label associat
  $('input,textarea').each(function() {
    var $el = $(this);
    var name = $(this).attr('name');
    var id = $(this).attr('id');
    var type = $(this).attr('type');
    
    // Si no te assignat el name posa el mateix que el id
    if (name == null) {
      name = $el.attr('id');
    } else {
      // Si el name no es null posa al id el mateix que el name
      if (id == null) $(this).attr('id', name);
    }

    var placeholder = null;

    if (type != 'radio' && type != 'checkbox') {
      if (this.localName == 'input') placeholder = $(this).attr('placeholder');
      if (this.localName == 'textarea') placeholder = $(this).attr('placeholder');
      if (this.localName == 'select') placeholder = this[0].text;
      // Si t placeholder s'ha de crear un label associat
      if (placeholder) {
        var label = $("<label for='" + name + "'>" + placeholder + "</label>");
        label.insertAfter(this);
      }
      // Si te valor es marca com a 'filled'
      if ($el.val()) {
        $el.addClass('filled');
      }
      // Assigna comportament en rebre el focus i perdre'l
      $(this).on('focus', function() {
        var $el = $(this);
        var label = $("label[for='" + $el.attr('id') + "']");
        label.css('left', $el.position().left + 12);
        label.css('top', $el.position().top - 20);
      });

      $(this).on('blur', function() {
        if ($(this).val()) {
          $(this).addClass('filled');
        } else
          $(this).removeClass('filled');
      });

    }

  });

  // Reposiciona els labels
  posiciona();
  // Assigna a la finestra gestor esdeveniment quan redimensiona per si s'han de reposicionar els labels 
  window.addEventListener("resize", posiciona);

});
