package myrobot.main;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import myrobot.main.comm.Callback;
import myrobot.main.comm.Communicator;

public class SettingsActivity extends Activity implements Callback {

    public static String ssid = null;
    public static String password = null;
    public static String robotIP = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_settings);

        SharedPreferences prop = getApplicationContext().getSharedPreferences("settings.properties", MODE_PRIVATE);
        robotIP = prop.getString("robotIP", "");
        ssid = prop.getString("ssid", "");
        password = prop.getString("password", "");

        TextView v  = (TextView) findViewById(R.id.ipText);
        v.setText(robotIP);
        v = findViewById(R.id.sidText);
        v.setText(ssid);
        v = findViewById(R.id.passwordText);
        v.setText(password);
    }

    public void save(View view) {
        String config = "";

        TextView v = findViewById(R.id.sidText);
        ssid = v.getText().toString();
        v = findViewById(R.id.passwordText);
        password = v.getText().toString();
        v = findViewById(R.id.ipText);
        robotIP = v.getText().toString();

        SharedPreferences prop = getApplicationContext().getSharedPreferences("settings.properties", MODE_PRIVATE);
        SharedPreferences.Editor editor = prop.edit();
        editor.putString("robotIP", robotIP);
        editor.putString("ssid", ssid);
        editor.putString("password", password);
        editor.commit();

        config += "\u0002";
        config += ssid + "~";
        config += password + "~";
        config += robotIP + "~";
        config += "\u0003";

        // Envia la configuració al robot
        Communicator.send("192.168.1.1", config, this);
    }


    @Override
    public void onResponseRequest(boolean result, String t) {
        if (result) {
            if ("OK".equals(t)) {
                Communicator.robotIP = robotIP;
                finish();
                return;
            }
        }
        final Context mContext = getApplicationContext();
        new Handler(Looper.getMainLooper()).post(new Runnable() {
            @Override
            public void run() {
                Toast toast = Toast.makeText(mContext, "Error configurando el robot. Debe conectar a la red MyRobot", Toast.LENGTH_SHORT);
                toast.show();
            }
        });


    }
}
